//#local stovedetail=1;
              
#local wax=texture {
  pigment {color rgbt <.95,.95,1,.1>}
  finish {ambient .2 specular .1 roughness .1 diffuse .4 phong .2}
}

#local aluminum=texture {
  pigment {color rgb .8}
  #if (stovedetail)
    finish {ambient .2 specular .3 roughness .2 diffuse .3 reflection .1}
  #end
} 

#declare candle=union {
  union {
    #if (stovedetail)
      intersection {
        cylinder {.11*y,.4*y,.75}
        torus { .75,.6 translate -.2*y }
      }
      difference {
        cylinder {.01*y,(.6/sqrt(2)-.2)*y,.65}
        sphere { .55*y, .75*sqrt(2)-.6}
      }
    #else
      cylinder {.11*y,.4*y,.75}
    #end
    
    texture {wax}
  }
  union {
    difference {
      cylinder { .03*y, .5*y, .76 }
      cylinder { .02*y, .51*y, .75 }
    }
    torus { .73, .03 translate .03*y}
    cylinder {0,.03*y,.73}
    texture {aluminum}
  }   
  #if (stovedetail)
    //wick
    intersection {
      torus {.4,.02 rotate 90*x translate <.4,.05,0> }
      sphere {0, .3}
      texture {pigment {color rgb 0}}
    }
  #end
}
 
#local pottery=texture {
  pigment {rgb <.8,.3,.1>}
  finish {ambient .2 diffuse .6 specular .2 roughness .3 phong 0}
}

#local glaze=texture {
  pigment {leopard 
    color_map {
      [.6 rgb <.7,.3,.1>]
      [1 rgb <.8,.7,.4>]
    }
    turbulence 3
    scale .02
  }
  #if (stovedetail)
    finish {ambient .2 diffuse .1 specular .4 roughness .02 reflection .1}
  #end
}
 
#local legpart=union { 
  union {
    box {<-.2,.3,-.1>, <.2,2,.1>}
    cylinder {<-.2,.3,0>,<-.2,2,0>, .1}
    cylinder {<.2,.3,0>,<.2,2,0>, .1}
    texture {
      gradient y
      texture_map {
        [.9 pottery]
        [1 glaze]
      }
      scale 2.01
    }
  }
  cylinder {<0,.3,-.1>,<0,.3,.1>, .2 texture {pottery}}
  torus {.2,.1 rotate 90*x translate .3*y texture {pottery}}
}

#local leg=union {
  object {legpart}
  #if (stovedetail)
    object {legpart scale <.3,.75,.2> translate <0,.5,-.1>}
  #end
}

#local bowl=union {
  intersection {
    sphere {0,1 
      texture {      
        gradient -y 
        texture_map {
          [0 glaze]
          [.2 pottery]
          [.7 pottery]
          [.8 pigment {rgb .05} finish {diffuse 1}]
        }
      turbulence .2
      scale 1.01
      }
    }
    box {-1.1, <1.1,0,1.1> texture {pottery}}
    sphere {0,.8 texture{glaze} inverse}
  }
  torus {.9,.1 texture{glaze}}
}
    

#local warmer=union {
  object {bowl translate sqrt(3)*y}
  object {leg rotate 30*x translate -1.9*z}
  object {leg rotate 30*x translate -1.9*z rotate 120*y}
  object {leg rotate 30*x translate -1.9*z rotate -120*y}
}

#declare stove=union {
  object {candle}
  object {warmer}  
  rotate 45*y
}

/*
plane {y,0 texture {pigment {checker rgb 0, rgb 1} scale .3}}
object {stove}
camera {location 2.1*y-5*z look_at y}
light_source {2.1*y-5*z rgb 1 spotlight radius 15 falloff 30 point_at 0}
light_source {<-12,12,-12> rgb 1}
*/