#local spool=union {
  cylinder { 0,1.99*y,.5 
    texture {
      pigment {color rgb <.6,.2,.2>}
      #if (tabledetail )
        normal {gradient y, .1 scallop_wave scale .002}
        finish {ambient .2 diffuse .6 phong 0}
      #end 
    }
  }   
  #if (tabledetail)
    intersection {
      torus { .7,.01 }
      box {<0,-.1,-2.1>,<2.1,.1,0>}
      translate -.7*x 
      rotate 5*z 
      translate <.45,1.2,0>
      texture {
        pigment {color rgb <.6,.2,.2>}
        finish {ambient .2 diffuse .6 phong 0}
      }
    }
  #end
  union {
    cylinder { 0,.05*y,.7 }
    cylinder { 1.99*y,1.95*y,.7 }
    #if (tabledetail )
      cone { .05*y,.7,.15*y,.5 }
      cone { 1.95*y,.7,1.85*y,.5 }
    #end
    texture {
      pigment {color rgb <1,1,.9>}
      #if (tabledetail)
        finish {ambient .2 diffuse .4 phong .2 specular .2 roughness .01}
      #end
    }
  } 
}   

#local lid=union {  
  #if (tabledetail )
    cylinder {.3*y,.31*y,1.5}
    difference {
      cylinder {.35*y,.36*y,2}
      cylinder {.34*y,.37*y,1.5}
    }
    torus { 1.5,.05 translate .31*y }
    torus {2,.1 translate .26*y }
    difference {
      cylinder {0,.26*y, 2.1}
      cylinder {-.01*y,.27*y,2.08}
    }
    torus {2.05,.05}
  #else
    difference {
      cylinder {-.05*y,.36*y,2.08}
      cylinder {.31*y,.37*y,1.5}
    }
  #end
  texture {
    pigment {color rgb <1,1,0>}
  }
  texture {
    pigment {image_map { gif "lidrim.gif" filter 255 1 map_type 2 } scale <1,.35,1>}
    finish {ambient .2 diffuse .5 specular .4 roughness .01}
  }
}

#local tCork =
texture {
    pigment {
        granite
        color_map {
            [0.00 rgb <0.93, 0.71, 0.532>]
            [0.60 rgb <0.98, 0.81, 0.60>]
            [0.60 rgb <0.50, 0.30, 0.20>]
            [0.65 rgb <0.50, 0.30, 0.20>]
            [0.65 rgb <0.80, 0.53, 0.46>]
            [1.00 rgb <0.85, 0.75, 0.35>]
        }
    }
    finish{ specular 0.1 roughness 0.5 }
    scale 0.25 
}

#local Cork=lathe {
  cubic_spline 
  12
  <-1,0> < 0,0> <.3,0>
  <.5,.1> <.4,.7> <.45,.7>
  <.5,.7> <.7,.8> <.7,1>
  <.5,1.2> <0,1.2> <-1,1.2>
  texture {tCork}
}
               
#declare table=union {
  object {lid translate 1.69*y}
  object {spool}
  object {Cork translate 2.2*x}
}
